/*

  Graphic user's interface library
  About dialog

  Author(s): Ilja V. Ryndin (ryndin@pinebrush.com)

  Start date: *

*/

#ifndef FLYABOUTDIALOG_H
#define FLYABOUTDIALOG_H

#include <QDialog>
#include <QString>

#include <flyintegration_global.h>

class FlyAboutDialogPrivate;

class FLYINTEGRATION_EXPORT FlyAboutDialog : public QDialog
{
    Q_OBJECT

public:
    explicit FlyAboutDialog(QWidget *parent, QString name = QString(),
                   QString version = QString(), QString description = QString(),
                   int startYear = -1, int endYear = -1, Qt::WindowFlags = Qt::Dialog);

    ~FlyAboutDialog();

    static void about(QWidget *parent, QString name = QString(),
                      QString version = QString(), QString description = QString(),
                      int startYear = -1, int endYear = -1, Qt::WindowFlags = Qt::Dialog);

protected:
    void paintEvent(QPaintEvent *e) override;

private:
    Q_DECLARE_PRIVATE(FlyAboutDialog)
    Q_DISABLE_COPY(FlyAboutDialog)
    FlyAboutDialogPrivate *d_ptr;

    Q_PRIVATE_SLOT(d_func(), void _q_openUrl(const QString &))
};

#endif // FLYABOUTDIALOG_H
