#ifndef FLYICONLABEL_H
#define FLYICONLABEL_H

#include <QLabel>
#include <QIcon>
#include <QStyle>

#include <flyintegration_global.h>

class FLYINTEGRATION_EXPORT FlyIconLabel : public QLabel
{
    Q_OBJECT
public:
    explicit FlyIconLabel(QWidget *parent = nullptr);

    void setIcon(const QIcon& icon);
    QIcon icon() const;

    // Default pixel metric is QStyle::PM_SmallIconSize
    QStyle::PixelMetric pixelMetricForIconSize() const;
    void setPixelMetricForIconSize(QStyle::PixelMetric pixelMetric);

protected:
    void changeEvent(QEvent *e) override;

private:
    void updatePixmap();

    QIcon m_icon;
    QStyle::PixelMetric m_pixelMetricForIconSize;
};

#endif
