#ifndef FLYSPLITTER_H
#define FLYSPLITTER_H

#include <QSplitter>

#include <flyintegration_global.h>

class FLYINTEGRATION_EXPORT FlySplitter : public QSplitter
{
    Q_OBJECT
    Q_PROPERTY(bool thinHandleModeEnabled READ isThinHandleModeEnabled WRITE setThinHandleModeEnabled)
public:
    explicit FlySplitter(QWidget *parent = nullptr);
    explicit FlySplitter(Qt::Orientation orientation, QWidget * parent = nullptr);

    bool isThinHandleModeEnabled() const;
    void setThinHandleModeEnabled(bool enable);

protected:
    QSplitterHandle* createHandle() override;

private:
    bool m_thinHandleMode;
};

class FlySplitterControl;

class FLYINTEGRATION_EXPORT FlySplitterHandle : public QSplitterHandle
{
    Q_OBJECT
public:
    FlySplitterHandle(Qt::Orientation o, FlySplitter *parent);
    ~FlySplitterHandle();
    FlySplitter* splitter() const;

    QSize sizeHint() const override;

    bool isThinHandleModeEnabled() const;
    void setThinHandleModeEnabled(bool enabled);

private:
    FlySplitterControl* m_splitterControl;
    bool m_thinHandleMode;
};

#endif // FLYSPLITTER_H
