#ifndef FLYSPLITTERCONTROL_H
#define FLYSPLITTERCONTROL_H

#include <QToolButton>

#include <flyintegration_global.h>

class QTimeLine;
class QSplitterHandle;

class FLYINTEGRATION_EXPORT FlySplitterControl : public QToolButton
{
    Q_OBJECT
public:
    explicit FlySplitterControl(QSplitterHandle* splitterHandle);
    ~FlySplitterControl();

protected:
    bool eventFilter(QObject *watched, QEvent *event) override;
    void paintEvent(QPaintEvent *) override;

    void showEvent(QShowEvent *) override;
    void changeEvent(QEvent *) override;

    void enterEvent(QEvent *) override;
    void leaveEvent(QEvent *) override;

    void mousePressEvent(QMouseEvent *e) override;
    void mouseMoveEvent(QMouseEvent *e) override;
    void mouseReleaseEvent(QMouseEvent *e) override;

private:
    bool isHorizontal() const;

    void updateIcon();
    void updatePosition();
    void updateOpacity(bool cursorEntered);

    QSplitterHandle* m_splitterHandle;
    QTimeLine* m_opacityTimeLine;

    QPoint m_mouseOffset;
    int m_controlPos;

    QPoint m_startPoint;
    bool m_movingHandle;
};

#endif // FLYSPLITTERCONTROL_H
